<?php
namespace Controller;

use Traits\TResponse;
use Util\InstanceProvider;
use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DataSource\DataSet;
use \Service\InitService;
use \Util\Utilities;
use \Util\Messages;


class InitController extends Simple {

    use TResponse;

	private $initService;

	public function __construct(InitService $initService)
    {
		$this->initService = $initService;
	}

	public function startSession(Request $request, Response $response)
    {
		try {
			$userInfo = $this->initService->restoreSession();
			$this->sendResponse($userInfo, 200);
		} catch(\Exception $e) {
            $this->sendResponse(['error' => $e->getMessage(), 'code' => $e->getCode()], 500);
		}
	}
}
