DECLARE
   V_CDSEQUENCIAL VARCHAR2(20) NULL;
BEGIN
    /*REGISTRANDO A PROCEDURE PARA O AGENDADOR DE EVENTOS*/
    SELECT COUNT(*)
    INTO   V_CDSEQUENCIAL
    FROM   EVENTOAEV 
    WHERE  NMOBJBDEVEN = 'ETL_ATENDTEK';
    
    IF V_CDSEQUENCIAL = 0 THEN     --> S ADICIONA A PROCEDURE SE ELA NO EXISTIR AINDA NO CADASTRO
        BEGIN
        
            SELECT LPAD(NVL(MAX(CDEVENTOAEV)+1,0),10,'0')
            INTO   V_CDSEQUENCIAL
            FROM   EVENTOAEV;
        
            INSERT INTO EVENTOAEV 
            (CDEVENTOAEV, NMEVENTOAEV, IDTPEVENAEV, CDOPERINCL, DTINCLEVEN, NMOBJBDEVEN)
            VALUES
            (V_CDSEQUENCIAL,'ETL Atendimento','STP','000000000999',SYSDATE,'ETL_ATENDTEK');
            
            INSERT INTO PARAMEVENTO
            (CDEVENTOAEV,NMPARAMEVEN,IDDADPARAMEVEN,IDTIPPARAMEVEN,DSPARAMEVEN,IDPARAMNULL,VRTAMPARAM,NRSEQPARAMEVEN) 
            VALUES
            (V_CDSEQUENCIAL,'P_DTINI','D','E','Data Inicial','N',0,'01');
            
            INSERT INTO PARAMEVENTO
            (CDEVENTOAEV,NMPARAMEVEN,IDDADPARAMEVEN,IDTIPPARAMEVEN,DSPARAMEVEN,IDPARAMNULL,VRTAMPARAM,NRSEQPARAMEVEN) 
            VALUES
            (V_CDSEQUENCIAL,'P_DTFINA','D','E','Data Final','N',0,'02');
        
            COMMIT;
        EXCEPTION
           WHEN OTHERS THEN
              RAISE_APPLICATION_ERROR (-20001,'Falha no cadastro de eventos agendveis.');
        END;
    ELSE
        RAISE_APPLICATION_ERROR (-20001,'Falha no cadastro de eventos agendveis. Evento j existe na base de dados.');
    END IF;
END;
/

DECLARE
   V_CDSEQUENCIAL VARCHAR2(20) NULL;
BEGIN
    /*REGISTRANDO A PROCEDURE PARA O AGENDADOR DE EVENTOS*/
    SELECT COUNT(*)
    INTO   V_CDSEQUENCIAL
    FROM   EVENTOAEV 
    WHERE  NMOBJBDEVEN = 'ETL_LIGACAOTEL';
    
    IF V_CDSEQUENCIAL = 0 THEN     --> S ADICIONA A PROCEDURE SE ELA NO EXISTIR AINDA NO CADASTRO
        BEGIN
        
            SELECT LPAD(NVL(MAX(CDEVENTOAEV)+1,0),10,'0')
            INTO   V_CDSEQUENCIAL
            FROM   EVENTOAEV;
        
            INSERT INTO EVENTOAEV 
            (CDEVENTOAEV, NMEVENTOAEV, IDTPEVENAEV, CDOPERINCL, DTINCLEVEN, NMOBJBDEVEN)
            VALUES
            (V_CDSEQUENCIAL,'ETL Ligaes Telefnicas','STP','000000000999',SYSDATE,'ETL_LIGACAOTEL');
            
            INSERT INTO PARAMEVENTO
            (CDEVENTOAEV,NMPARAMEVEN,IDDADPARAMEVEN,IDTIPPARAMEVEN,DSPARAMEVEN,IDPARAMNULL,VRTAMPARAM,NRSEQPARAMEVEN) 
            VALUES
            (V_CDSEQUENCIAL,'P_DTINI','D','E','Data Inicial','N',0,'01');
            
            INSERT INTO PARAMEVENTO
            (CDEVENTOAEV,NMPARAMEVEN,IDDADPARAMEVEN,IDTIPPARAMEVEN,DSPARAMEVEN,IDPARAMNULL,VRTAMPARAM,NRSEQPARAMEVEN) 
            VALUES
            (V_CDSEQUENCIAL,'P_DTFINA','D','E','Data Final','N',0,'02');
        
            COMMIT;
        EXCEPTION
           WHEN OTHERS THEN
              RAISE_APPLICATION_ERROR (-20001,'Falha no cadastro de eventos agendveis.');
        END;
    ELSE
        RAISE_APPLICATION_ERROR (-20001,'Falha no cadastro de eventos agendveis. Evento j existe na base de dados.');
    END IF;
END;
/

/*Cadastrando os fatos e dimenses para o DW*/
BEGIN
   CRIA_FATOS('ETLLIGACAOTEL', 'VRLIGTEL',       'Valor da Ligao',              'Gesto de Telefones');
   CRIA_FATOS('ETLLIGACAOTEL', 'VRDURALIGTELR',  'Durao de Ligaes Recebidas', 'Gesto de Telefones');
   CRIA_FATOS('ETLLIGACAOTEL', 'VRDURALIGTELO',  'Durao de Ligaes Originadas','Gesto de Telefones');
   CRIA_FATOS('ETLLIGACAOTEL', 'QTLIGTEL',       'Quantidade de Ligaes',        'Gesto de Telefones');   
   
   CRIA_DIME('ETLLIGACAOTEL',   'CDFILIAL',      'Filial',             'FILIAL',       'CDFILIAL',       'NMFILIAL',     NULL); 
   CRIA_DIME('ETLLIGACAOTEL',   'ANETLLIGTEL',   'Ano',                NULL,           NULL,             NULL,           NULL);    
   CRIA_DIME('ETLLIGACAOTEL',   'MEETLLIGTEL',   'Ms',                NULL,           NULL,             NULL,           NULL);    
   CRIA_DIME('ETLLIGACAOTEL',   'NMLOCALLIGTEL', 'Localidade',         NULL,           NULL,             NULL,           NULL);  
   CRIA_DIME('ETLLIGACAOTEL',   'DSTPENTLIGTEL', 'Tipo de Entidade',   NULL,           NULL,             NULL,           NULL);     
   CRIA_DIME('ETLLIGACAOTEL',   'NRRAMALLIGTEL', 'Ramal',              NULL,           NULL,             NULL,           NULL);         
   CRIA_DIME('ETLLIGACAOTEL',   'NRTELLIGTEL',   'Nmero do Telefone', NULL,           NULL,             NULL,           NULL);         
   CRIA_DIME('ETLLIGACAOTEL',   'NMENTLIGTEL',   'Entidade',           NULL,           NULL,             NULL,           NULL);         
   CRIA_DIME('ETLLIGACAOTEL',   'DSTIPLIGTEL',   'Tipo de Ligao',    NULL,           NULL,             NULL,           NULL);            
   
   COMMIT; 
END;
/

BEGIN
   CRIA_FATOS('ETLLIGACAOTEL', 'VRDURALIGTEL', 'Durao da Ligao', 'Gesto de Telefones');
   CRIA_DIME('ETLLIGACAOTEL', 'DSSENTLIGTEL', 'Sentido da Ligao', NULL, NULL, NULL, NULL);
   COMMIT;
END;
/

